/*
	Blizzards Plugins Comply With GNU General Public License
	
	Death From Above is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	Under no circumstances are you allowed to redistribute and/or modify
	it claming that you are the original author of such plugin/modification.
	
	Death From Above is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	Plugin Thread
	=============
	https://forums.alliedmods.net/showthread.php?t=228317
	
	Death From Above
	================
	This Plugin Allows The Player To Purchase An Ability Called 'Death From Above'
	Once Purchased The Player Can Then Use His +jump Button To Leap High Into The Air
	Then Once At Height Player Likes Then Presses +duck Button To Plummet Back To The Ground Thus
	Creating A Explosion Dealing Damage/Killing Nearby Enemys.
	
	Cvars
	-----
	Damage Can Be Dealt 2 Ways.
	dfa_mode		"0" = Plugin Set To Off
				"1" = Explosion Damage Dealth From Fall Dmg
				"2" = Explosion Damage Dealth From dfa_dmg_amount cvar amount
	dfa_cost 		"1000" = Price In Money For Purchasing DFA
	dfa_debug 		"0" = Sets Debug Messages Off
				"1" = Shows Amount Of Damage From Fall/Cvar Damge In Client_Print Msgs
	dfa_acend_power 	"1000.0" = The Velocity Power Player Gets For Jumping.
	dfa_decend_power	"2000.0" = The Velocity Power Player Is Plummeted To Ground ( Higher Number Faster Player Falls )
					   Higher Fall Velocity Higher Damage On dfa_mode "1"
	dfa_dmg_amount		"200" = the damage dealth within the explosion if dfa_mode "2" set
	
	Client Commands
	---------------
	say /dfa = Buys Death From Above Ability.
	
	Credits
	-------
	Blizzard - Author & Idea
	
	ChangeLog
	---------
	October 20/10/2013
	- v1.0.2 -	[ FIXED ]	bug if pressing crouch multi times whilst on ground would kill player
	
	October 19/10/2013
	- v1.0.1 -	[ FIXED ]	glitch with using jump multi times to fly.
	
	October 18/10/2013
	- v1.0.0 -	Original Release.
	
	
	
*/

#include < amxmodx >
#include < amxmisc >
#include < hamsandwich >
#include < fakemeta >
#include < fun >
#include < engine >
#include < cstrike >

#pragma semicolon 1

#define PLUGIN "Death From Above"
#define VERSION "1.0.2"
#define AUTHOR "Blizzard"

#define cm(%0)				( sizeof(%0) - 1 )

#define BitSet(%0,%1)          		( %0 |= ( 1 << ( %1 & 31 ) ) )
#define BitClear(%0,%1)         	( %0 &= ~( 1 << ( %1 & 31 ) ) )
#define BitCheck(%0,%1)         	( %0 & ( 1 << ( %1 & 31 ) ) )

new BitDFA, BitInJump;

// Ham Hooks
new HamHook:_CBasePlayer_PreDamage;

// Constants
const FALL_DMG = ( 1<<5 );

// Cvars
new g_pMode, g_pDmgAmount, g_pDfaCost, g_pDebug, g_pAcendPower, g_pDecendPower;
new g_iBlinkAcct;

public plugin_init( ) 
{
	register_plugin( PLUGIN, VERSION, AUTHOR );
	server_print( "^n^t%s v%s, Copyright (C) 2013 by %s^n", PLUGIN, VERSION, AUTHOR );
	register_cvar( "dfa_version", VERSION, FCVAR_SERVER|FCVAR_SPONLY );
	
	// Register Ham
	RegisterHam( Ham_Player_Jump, "player", "CBasePlayer_Jump_Post", true );
	RegisterHam( Ham_Player_Duck, "player", "CBasePlayer_Duck_Post", true );
	RegisterHam( Ham_Killed, "player", "CBasePlayer_Killed_Post", true );
	DisableHamForward( _CBasePlayer_PreDamage = RegisterHam( Ham_TakeDamage, "player", "CBasePlayer_TakeDamage", false ) );
et_user_msgid( "BlinkAcct" );
	
	// Register Client Commands
	register_clcmd( "say /dfa", "CmdDeathFromAbove" );
}

/*---------------------------
-
-	Forwards
-
---------------------------*/

public client_putinserver( id )
	set_task( 0.9, "ShowHud", id, _, _, "b" );

public CmdDeathFromAbove( id )
{
	if( !get_pcvar_num( g_pMode ) )
		return PLUGIN_HANDLED;
	
	if( is_user_alive( id ) && get_pcvar_num( g_pMode ) )
	{
		
	
		Reduce( id, iCost );
		ColorMsg( id, "!g[ DFA ]!n You Bought !gDeath From Above!n Ability!" );
		BitSet( BitDFA, id );
	}
	return PLUGIN_HANDLED;
}

public CBasePlayer_Duck_Post( id )
{
	if( BitCheck( BitDFA, id ) && BitCheck( BitInJump, id ) )
	{
		SetUserVelocity( id, - get_pcvar_float( g_pDecendPower ) );
	}

}

public CBasePlayer_Jump_Post( id )
{
	if( BitCheck( BitDFA, id ) && !BitCheck( BitInJump, id ) )
	{
		SetUserVelocity( id, get_pcvar_float( g_pAcendPower ) );
		BitSet( BitInJump, id );
		EnableHamForward( _CBasePlayer_PreDamage );
	}
}

public CBasePlayer_TakeDamage( id, iInflictor, iAttacker, Float:flDamage, bitsDamageType )
{	
	if( bitsDamageType == FALL_DMG )
	{
		if( BitCheck( BitDFA, id ) )
		{
			if( get_pcvar_num( g_pDebug ) ) // Debugging Purposes Only
				client_print( id, print_center, "DFA Fall Dmg ( %d )", float_to_num( flDamage ) );
			
			SetHamReturnInteger( 0 );
			ExecuteExplosion( id, flDamage );
			DisableHamForward( _CBasePlayer_PreDamage );
			
			BitClear( BitInJump, id );
			BitClear( BitDFA, id );
			return HAM_SUPERCEDE;
		}
	}
	return HAM_IGNORED;
}

public CBasePlayer_Killed_Post( id, ikiller, shouldgib )
{
	if( BitCheck( BitDFA, id ) )
	{
		DisableHamForward( _CBasePlayer_PreDamage );
	}
}

public ShowHud( id )
{
	if( BitCheck( BitDFA, id ) && is_user_alive( id ) )
	{
		set_hudmessage( 0, 255, 0, 0.12, 0.06, 1, 1.0, 0.5, 0.5, 0.5, -1 );
		show_hudmessage( id, "Death From Above^nActivated!" );
	}
}
		

/*--------------------------------
-
-	Stocks
-
--------------------------------*/
stock ExplosionCreate( const Float:vecCenter[3], iMagnitude, iFlags = 0 )
{
	new iEnt = create_entity( "env_explosion" );
	
	if( !iEnt )
		return 0;
	
	entity_set_origin( iEnt, vecCenter );
	
	new szMagnitude[ 8 ];
	formatex( szMagnitude, cm( szMagnitude ), "%3d", iMagnitude );
	DispatchKeyValue( iEnt, "iMagnitude", szMagnitude );
	
	entity_set_int( iEnt, EV_INT_spawnflags, iFlags );
	
	DispatchSpawn( iEnt );
	
	force_use( iEnt, iEnt );
	
	return iEnt;
}  

stock ExecuteExplosion( id, Float:Dmg )
{
	new Float:vecOrigin[ 3 ], iNum = get_pcvar_num( g_pMode );
	entity_get_vector( id, EV_VEC_origin, vecOrigin );
	no_team_dmg( cs_get_user_team( id ), true );
	switch( iNum )
	{
		case 0: return;
		case 1: ExplosionCreate( vecOrigin, float_to_num( Dmg ), 1 );
		case 2: 
		{
			ExplosionCreate( vecOrigin, get_pcvar_num( g_pDmgAmount ), 1 );
			if( get_pcvar_num( g_pDebug ) ) // Debugging Purposes Only
				client_print( id, print_chat, "DFA Mode 2 Dmg ( %d )", get_pcvar_num( g_pDmgAmount ) );
		}
	}
	no_team_dmg( cs_get_user_team( id ), false );
}

stock float_to_num( Float:flDamage )
{
	new szDmg[ 8 ], iNum;
	float_to_str( flDamage, szDmg, cm( szDmg ) );
	iNum = str_to_num( szDmg );
	return iNum;
}

stock Reduce( id, amount )
{
	cs_set_user_money( id, cs_get_user_money( id ) - amount, 1 );
}

stock NotEnoughMoney( id )
{
	client_print(id, print_center, "#Cstrike_TitlesTXT_Not_Enough_Money");

	message_begin(MSG_ONE_UNRELIABLE, g_iBlinkAcct, .player=id);
	{
		write_byte(2);
	}
	message_end();
}

stock SetUserVelocity( id, Float:flForce )
{
	new Float:Velocity[ 3 ];
	pev(id, pev_velocity, Velocity);
	Velocity[2] = flForce;
	set_pev(id, pev_velocity, Velocity);
}

stock ColorMsg( id, String[ ], any:... ) {
	static szMsg[ 192 ];
	vformat( szMsg, charsmax( szMsg ), String, 3 );
	
	replace_all( szMsg, charsmax( szMsg ), "!n", "^1" );
	replace_all( szMsg, charsmax( szMsg ), "!t", "^3" );
	replace_all( szMsg, charsmax( szMsg ), "!g", "^4" );
	
	static msgSayText = 0;
	if( !msgSayText ) msgSayText = get_user_msgid( "SayText" );
	
	new Players[ 32 ], iNum = 1, i; 
	
	if( id ) Players[ 0 ] = id;    
	else get_players( Players, iNum, "ch" );
	
	for( --iNum; iNum >= 0; iNum-- ) {
		i = Players[ iNum ];
		
		message_begin( MSG_ONE_UNRELIABLE, msgSayText, _, i );
		write_byte( i );
		write_string( szMsg );
		message_end( );
	}
}

stock no_team_dmg( CsTeams:Team, bool:active )
{
	new iPlayers[ 32 ], iNum, i, Players;
	get_players( iPlayers, iNum, "ae", Team == CS_TEAM_CT ? "CT" : "TERRORIST" );
	for( i = 0; i < iNum; i++ )
	{
		Players = iPlayers[ i ];
		switch( active )
		{
			case true: set_user_godmode( Players, 1 );
			case false:set_user_godmode( Players, 0 );
		}
	}
}
